<?php

namespace Drupal\locker\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;

class LockCont extends ControllerBase {

  public function content() {

    $content = array();

    $form = \Drupal::formBuilder()->getForm('Drupal\locker\Form\UnlockForm');
    unset($form['actions']['submit']);

    $content['form'] = \Drupal::service('renderer')->renderRoot($form);
    $content['css'] = '<link type="text/css" rel="stylesheet" href="'
      . base_path() . drupal_get_path('module', 'locker') . '/css/locker.css'
      . '" media="all" />';

    $content['js'] =
      //'<s'.'cript type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></s'.'cript>'.
      '<s'.'cript type="text/javascript" src="'.base_path() .drupal_get_path('core', 'libraries') . '/assets/vendor/jquery/jquery.min.js' .'"></s'.'cript>'.
      '<s'.'cript src="'.base_path() . drupal_get_path('module', 'locker') . '/js/locker.js' .'"></s'.'cript>';

    $content['locker_access_options'] = \Drupal::config('locker.settings')->get('locker_access_options');
    if(isset($form['error_message'])) {
      $content['error_message'] = $form['error_message'];
    }

    $elements = array(
      '#theme' => 'locker',
      '#vars' => $content,
    );
    //return $elements;

    $html = \Drupal::service('renderer')->render($elements);
    $response = new Response($html,Response::HTTP_OK, array('content-type' => 'text/html'));
    return $response;

  }
}
