<?php

namespace Drupal\locker\EventSubscriber;

use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\KernelEvents;
use Symfony\Component\HttpKernel\Event\GetResponseEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class LockerSubscriber implements EventSubscriberInterface {

  public function checkForRedirection(GetResponseEvent $event) {

    global $base_url;
    $current_page = \Drupal::service('path.current')->getPath();
    $config = \Drupal::config('locker.settings');
    $active_value = $config->get('locker_site_locked', NULL);
    $uri = $config->get('locker_custom_url');

    if($active_value) {
      if ($current_page != '/'.$uri) {
        if (!isset($_SESSION['locker_unlocked'])) {
          $event->setResponse(new RedirectResponse($base_url.'/'.$uri));
        }
      }
      elseif ($current_page == '/'.$uri) {
        if (isset($_SESSION['locker_unlocked']) && $_SESSION['locker_unlocked'] == 'yes') {
          $event->setResponse(new RedirectResponse($base_url));
        }
      }
    }
    return false;
  }

  public static function getSubscribedEvents() {

    $events[KernelEvents::REQUEST][] = array('checkForRedirection');
    return $events;
  }

}
