<?php

namespace Drupal\locker\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Entity\EntityInterface;

class UnlockForm extends ConfigFormBase {

  public function getFormId() {
    return 'locker-unlock-form';
  }

  protected function getEditableConfigNames() {
    return ['locker.login'];
  }

  public function buildForm(array $form, FormStateInterface $form_state, EntityInterface $node = NULL) {
      $config = $this->config('locker.settings');
      $locker_access_options = $config->get('locker_access_options');

    if (in_array($locker_access_options,['user_pass','roles'])) {
      $form['username'] = array(
        '#type' => 'textfield',
        '#attributes' => array('placeholder' => $this->t('Username')),
        '#prefix' => '<div class="form-item--label">' . t('Enter your ') . '<span>' . t('Username ') . '</span>' . t(' to gain access') . '</div>',
     );

      $form['password'] = array(
        '#type' => 'password',
        '#attributes' => array('placeholder' => $this->t('Password')),
       '#prefix' => '<div class="form-item--label">' . t('Enter your Account ') . '<span>' . t('Password') . '</span></div>',
      );
    } elseif ($locker_access_options == 'passphrase') {
      $form['passphrase'] = array(
        '#type' => 'password',
        '#attributes' => array('placeholder' => $this->t('Passphrase')),
        '#prefix' => '<div class="form-item--label">' . t('Enter the ') . '<span>' . t('Passphrase') . '</span>' . t(' to gain access') . '</div>',
      );
    }

    $form['submit'] = array(
      //'#prefix' => '<div class="js-form-item form-item js-form-type-textfield form-type-textfield js-form-item-username form-item-username form-no-label">', '#sufix' => '</div>',
      '#type' => 'submit',
      '#attributes' => array('class' => array('form-submit'), 'style' => ''),
      '#value' => t('Unlock'),
    );

    //$form['developed'] = array(
    //  '#markup' => '<p class="error__message">Developed by <a class="error__message" href="http://www.websolutions.hr/">WEBSOLUTIONS | HR</a></p>',
    //);

    $form['#attached']['library'][]= 'locker/locker-unlockform';

    return parent::buildForm($form, $form_state);
  }

  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  public function submitForm(array &$form, FormStateInterface $form_state) {

    global $base_url;
    $unlocked = false;

    //getConfig Readonly
    $config = $this->config('locker.settings'); //$config = \Drupal::config('locker.settings');
    //getConfig Read/Write
    //$config = \Drupal::service('config.factory')->getEditable('locker.settings');

    $locker_access_options = $config->get('locker_access_options');

      if($locker_access_options  == 'user_pass') {
        $user_unlock = $form_state->getValue('username');
        $pass_unlock = $form_state->getValue('password');
        $password_unlock = $config->get('locker_password');
        $username_unlock = $config->get('locker_user');
        if ($user_unlock == $username_unlock AND md5($pass_unlock) == $password_unlock) {
          $unlocked = true;
        }
      }
      elseif($locker_access_options == 'passphrase') {
        $passphrase = $form_state->getValue('passphrase');
        $passphrase_unlock = $config->get('locker_passphrase');
        if(md5($passphrase) == $passphrase_unlock) {
          $unlocked = true;
        }
      }
      elseif($locker_access_options  == 'roles'){
        $user_unlock = $form_state->getValue('username');
        $pass_unlock = $form_state->getValue('password');
        $uid = \Drupal::service('user.auth')->authenticate($user_unlock, $pass_unlock);
        if($uid) {
          $account = \Drupal\user\Entity\User::load($uid);
          $roles = $config->get('roles');
          foreach ($roles as $role => $true) {
            if (!empty($true) && $account->hasPermission($role)) {
              $roles_autologin = $config->get('roles_autologin');
              if($roles_autologin && isset($roles_autologin['auto_login']) && $roles_autologin['auto_login']){
                user_login_finalize($account);
              }
              $unlocked = true;
              break;
            }
          }
        }
      }

      if ($unlocked) {
        $_SESSION['locker_unlocked'] = 'yes';
        \Drupal::state()->delete('locker_login_error');
      }
      else {
        \Drupal::state()->set('locker_login_error', 'yes');
      }

      parent::submitForm($form, $form_state);
    }
}
